org.eclipse.viatra.query.runtime.api

## Class ViatraQueryEngineOptions

- java.lang.Object
- - org.eclipse.viatra.query.runtime.api.ViatraQueryEngineOptions

-     public final class ViatraQueryEngineOptions
      extends java.lang.Object

  This class is intended to provide options to a created `ViatraQueryEngine` instance. The `DEFAULT` instance represents the configuration that is selected when no explicit options are provided by the user. To create new configurations, use the static builder methods `defineOptions()` (starts with empty options) or `copyOptions(ViatraQueryEngineOptions)` (starts with all options from an existing configuration).
  Since:
    1.4

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ViatraQueryEngineOptions.Builder`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static ViatraQueryEngineOptions` | `DEFAULT` The default engine options; if options are not defined, this version will be used.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ViatraQueryEngineOptions.Builder` | `copyOptions(ViatraQueryEngineOptions options)` Initializes an option builder with settings from an existing configuration.
    `static ViatraQueryEngineOptions.Builder` | `defineOptions()` Initializes an option builder with no previously set options.
    `IQueryBackendFactory` | `getDefaultBackendFactory()` Returns the configured default backend
    `IQueryBackendFactory` | `getDefaultCachingBackendFactory()` Returns the configured default caching backed.
    `QueryEvaluationHint` | `getEngineDefaultHints()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT

          public static final ViatraQueryEngineOptions DEFAULT

      The default engine options; if options are not defined, this version will be used.

  - ### Method Detail

    - #### defineOptions

          public static ViatraQueryEngineOptions.Builder defineOptions()

      Initializes an option builder with no previously set options.

    - #### copyOptions

          public static ViatraQueryEngineOptions.Builder copyOptions(ViatraQueryEngineOptions options)

      Initializes an option builder with settings from an existing configuration.

    - #### getEngineDefaultHints

          public QueryEvaluationHint getEngineDefaultHints()

    - #### getDefaultBackendFactory

          public IQueryBackendFactory getDefaultBackendFactory()

      Returns the configured default backend
      Returns:
        the defaultBackendFactory

    - #### getDefaultCachingBackendFactory

          public IQueryBackendFactory getDefaultCachingBackendFactory()

      Returns the configured default caching backed. If the default backend caches matches, it is usually expected, but not mandatory for the two default backends to be the same.

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`